unit Mstatus;

{

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TForm1.ShowHint(Sender: TObject);
begin
  Status1.Caption := Application.Hint;
end;

Don't forget!!!!!

You will have to manually add a forward declaration for the ShowHint procedure to the TForm1 class
definition at the top, which would look like this:

type
  TForm1 = class(TForm)
    procedure ShowHint(Sender: TObject);
    (etc...)
  end;}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Menus, Gauges;

type
  TMStatus = class(TCustomPanel)
  private
    FDate         : Boolean;
    FKeys         : Boolean;
    FTime         : Boolean;
    FResources    : Boolean;
    DateTimePanel : TPanel;
    ResPanel      : TPanel;
    ResGauge      : TGauge;
    ResGauge1     : TGauge;
    ResGauge2     : TGauge;
    CapPanel      : TPanel;
    ProgressPanel : TPanel;

    Gauge          : TGauge;
    FGaugeBoxColor : TColor;
    FGaugeHint     : String;
    FGaugeMax      : LongInt;
    FGaugeMin      : LongInt;
    FGaugeProgress : LongInt;
    FProgress      : Boolean;

    gaugePanel    : TPanel;
    NumPanel      : TPanel;
    InsPanel      : TPanel;
    HelpPanel     : TPanel;
    UpdateWidth   : Boolean;
    FTimer        : TTimer;

    Procedure SetProgress(a:Boolean);
    procedure SetDate(A: Boolean);
    procedure SetKeys(A: Boolean);
    procedure SetTime(A: Boolean);
    procedure SetResources(A: Boolean);
    procedure SetCaption(A: String);
    Function  GetCaption: String;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure SetGaugeBoxColor(Value: TColor);
    procedure SetGaugeHint(Value: String);
    procedure SetGaugeMax(Value: LongInt);
    procedure SetGaugeMin(Value: LongInt);
    procedure SetGaugeProgress(Value: LongInt);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetupPanelFields(ThePanel: TPanel);
    procedure SetupPanel(ThePanel: TPanel; WidthMask: String);
    procedure UpdateStatusBar(Sender: TObject);
    procedure MShowHint(Sender: TObject);
  published
    property GaugeBoxColor: TColor read FGaugeBoxColor write SetGaugeBoxColor;
    property GaugeHint: String read FGaugeHint write SetGaugeHint;
    property GaugeMax: LongInt read FGaugeMax write SetGaugeMax;
    property GaugeMin: LongInt read FGaugeMin write SetGaugeMin;
    property GaugeProgress: LongInt read FGaugeProgress write SetGaugeProgress;

    property ShowDate: Boolean read FDate write SetDate default True;
    property ShowKeys: Boolean read FKeys write SetKeys default True;
    property ShowTime: Boolean read FTime write SetTime default True;
    property ShowProgress: Boolean read FProgress write SetProgress default True;
    property ShowResources: Boolean read FResources write SetResources default
True;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderStyle;
    property BorderWidth;
    property Caption: string read GetCaption write SetCaption;

    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3d;
    property ParentFont;
    property ParentShowHint;
    property PopUpMenu;
    property ShowHint;
    property Visible;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('miks', [TMStatus]);
end;

procedure TMStatus.SetupPanelFields(ThePanel: TPanel);
begin
  with ThePanel do
    begin
      Alignment := taCenter;
      Caption := '';
      BevelInner := bvLowered;
      BevelOuter := bvNone;
      ParentColor := True;
      ParentFont := True;
      ParentCtl3D := True;
    end;
end;

procedure TMStatus.SetupPanel(ThePanel: TPanel; WidthMask: String);
begin
  SetupPanelFields(ThePanel);
  with ThePanel do
    begin
      Width := Canvas.TextWidth(WidthMask);
      Align := alRight;
    end;
end;

constructor TMStatus.Create(AOwner: TComponent);
begin
  Application.OnHint := MShowHint;
  DateSeparator := '-'; {change this to your needs}
  Shortdateformat := 'dd-mm-yyyy';
  Shorttimeformat := 'hh:nn:nn';
  inherited Create(AOwner);
  Parent := TWinControl(AOwner);
  FTime := True;
  FDate := True;
  FKeys := True;
  FProgress:=True;
  FResources := True;

  {Force the status bar to be aligned bottom}
  Align := alBottom;
  Height := 20;
  BevelInner := bvNone;
  BevelOuter := bvRaised;

  {When UpdateWidth is set TRUE, status bar will recalculate panel widths once}
  UpdateWidth := True;
  Locked := True;
  TabOrder := 0;
  TabStop := False;
  Font.Name := 'Arial';
  Font.Size := 8;

  {Create the panel that will hold the date & time}
  DateTimePanel := TPanel.Create(Self);
  DateTimePanel.Parent := Self;
  with datetimepanel do begin
    Hint:='Date/Time';
    ShowHint:=True;
  end;
  SetupPanel(DateTimePanel,'  00-00-0000 00:00  ');

  {Create the 2 Gauges that will reside within the Resource Panel}
  ResPanel := TPanel.Create(Self);
  ResPanel.Parent := Self;
  SetupPanel(ResPanel,'');
  ResPanel.Width:=100;

  ResGauge := TGauge.Create(Self);
  with ResGauge do begin
    Hint:='System resources';
    ShowHint:=True;
    Parent := ResPanel;
    Width := (ResPanel.Width-8) div 3;
    Align := alLeft;
    ParentFont := True;
    BackColor := Color;
    ForeColor := clLime;
    BorderStyle := bsSingle;
  end;
  ResGauge1 := TGauge.Create(Self);
  with ResGauge1 do begin
    Hint:='GDI resources';
    ShowHint:=True;
    Parent := ResPanel;
    Width := (ResPanel.Width-8) div 3;
    Align := alLeft;
    ParentFont := True;
    BackColor := Color;
    ForeColor := clAqua;
    BorderStyle := bsSingle;
  end;
  ResGauge2 := TGauge.Create(Self);
  with ResGauge2 do begin
    Parent := ResPanel;
    Hint:='User resources';
    ShowHint:=True;
    Width := (ResPanel.Width-8) div 3;
    Align := alClient;
    ParentFont := True;
    BackColor := Color;
    ForeColor := clFuchsia;
    BorderStyle := bsSingle;
  end;

  {Create the panel that will hold the CapsLock state}
  CapPanel := TPanel.Create(Self);
  CapPanel.Parent := Self;
  SetupPanel(CapPanel,'  Cap  ');

  {Create the panel that will hold the NumLock state}
  NumPanel := TPanel.Create(Self);
  NumPanel.Parent := Self;
  SetupPanel(NumPanel,'  Num  ');

  {Create the panel that will hold the Insert/Overwrite state}
  InsPanel := TPanel.Create(Self);
  InsPanel.Parent := Self;
  SetupPanel(InsPanel,'  Ins  ');

  {Create the panel that will hold the status text}
  HelpPanel := TPanel.Create(Self);
  HelpPanel.Parent := Self;
  SetupPanelFields(HelpPanel);

  {Have the help panel}
  HelpPanel.Align := alClient;
  HelpPanel.Alignment := taLeftJustify;
  HelpPanel.Caption:=' miks computers inc.';

  {Set the Gauge}

  {Create the panel that will hold the progress}
  ProgressPanel := TPanel.Create(Self);
  with ProgressPanel do begin
    Parent := Self;
    Hint:='Progress meter';
    ShowHint:=True;
    SetupPanel(ProgressPanel,'                  ');
    Align:=AlLeft;
    Width:=100;
    BorderStyle:=BsNone;
  end;

  Gauge := TGauge.Create(Self);
  with Gauge do
  begin
    Align := alClient;
    Parent := ProgressPanel;
    ParentColor := True;
    BorderStyle:=BsNone;
  end;

  FGaugeBoxColor := clNavy;
  FGaugeMax := 100;
  FGaugeMin := 1;
  FGaugeProgress := 0;

  FTimer := TTimer.Create(Self);
  If FTimer <> Nil then
    begin
      FTimer.OnTimer := UpdateStatusBar;
      FTimer.Interval := 1000;
      FTimer.Enabled := True;
    end;
end;

destructor TMStatus.Destroy;
begin
  FTimer.Free;
  HelpPanel.Free;

  InsPanel.Free;
  NumPanel.Free;
  CapPanel.Free;
  ResGauge.Free;
  ResPanel.Free;
  DateTimePanel.Free;
  inherited Destroy;
end;

procedure TMStatus.SetDate(A: Boolean);
begin
  FDate := A;
  UpdateWidth := True;
end;

procedure TMStatus.SetKeys(A: Boolean);
begin
  FKeys := A;
  UpdateWidth := True;
end;

procedure TMStatus.SetProgress(A: Boolean);
begin
  FProgress := A;
  UpdateWidth := True;
end;

procedure TMStatus.SetTime(A: Boolean);
begin

  FTime := A;
  UpdateWidth := True;
end;

procedure TMStatus.SetResources(A: Boolean);
begin
  FResources := A;
  UpdateWidth := True;
end;

{When we set or get the TMStatus caption, it is affecting the HelpPanel caption
instead}
procedure TMStatus.SetCaption(A: String);
begin
  if (a>'') and (a[1]<>' ') then a:=' '+a;
  HelpPanel.Caption := A;
end;

function TMStatus.GetCaption: String;
begin
  GetCaption := HelpPanel.Caption;
end;

{This procedure sets the captions appropriately}
procedure TMStatus.UpdateStatusBar(Sender: TObject);
begin
  if ShowDate and ShowTime then
    DateTimePanel.Caption := DateTimeToStr(Now)
  else
    if ShowDate and not ShowTime then
      DateTimePanel.Caption := DateToStr(Date)
    else
      if not ShowDate and ShowTime then

        DateTimePanel.Caption := TimeToStr(Time)
      else
        DateTimePanel.Caption := '';
  if UpdateWidth then with DateTimePanel do
    if ShowDate or ShowTime then
      Width := Canvas.TextWidth('  '+Caption+'  ')
    else
      Width := 0;
  if UpdateWidth then
    if ShowResources then
      ResPanel.Width := 100
    else
      ResPanel.Width := 0;

  if ShowResources then
    begin
      ResGauge.Width := (ResPanel.Width-8) div 3;
      ResGauge1.Width := (ResPanel.Width-8) div 3;
      ResGauge.Progress := GetFreeSystemResources(GFSR_SYSTEMRESOURCES);
      if ResGauge.Progress < 40 then
        ResGauge.ForeColor := clYellow;
      if ResGauge.Progress < 20 then
        ResGauge.ForeColor := clRed
      else
        ResGauge.ForeColor := clLime;

      ResGauge1.Progress := GetFreeSystemResources(GFSR_GDIRESOURCES);
      if ResGauge1.Progress < 40 then
        ResGauge1.ForeColor := clYellow;
      if ResGauge1.Progress < 20 then
        ResGauge1.ForeColor := clRed
      else
        ResGauge1.ForeColor := clAqua;

      ResGauge2.Progress := GetFreeSystemResources(GFSR_USERRESOURCES);
      if ResGauge2.Progress < 40 then
        ResGauge2.ForeColor := clYellow;
      if ResGauge2.Progress < 20 then
        ResGauge2.ForeColor := clRed
      else
        ResGauge2.ForeColor := clFuchsia;
    end;

  if ShowKeys then
    begin
      if (GetKeyState(vk_NumLock) and $01) <> 0 then
        NumPanel.Caption := '  Num  ' else NumPanel.Caption := '';
      if (GetKeyState(vk_Capital) and $01) <> 0 then
        CapPanel.Caption := '  Cap  ' else CapPanel.Caption := '';
      if (GetKeyState(vk_Insert) and $01) <> 0 then
        InsPanel.Caption := '  Ins  ' else InsPanel.Caption := '';
    end;
  {if UpdateWidth then if ProgressPanel.FProgress then} 
  if UpdateWidth then
    if ShowKeys then

      begin
        NumPanel.Width := Canvas.TextWidth(' Num ');
        InsPanel.Width := Canvas.TextWidth(' Ins ');
        CapPanel.Width := Canvas.TextWidth(' Cap ');
      end
    else
      begin
        NumPanel.Width := 0;
        InsPanel.Width := 0;
        CapPanel.Width := 0;
      end;
  UpdateWidth := False;
end;

{This allows font changes to be detected so the panels will be adjusted}

procedure TMStatus.CMFontChanged(var Message: TMessage);
begin
  inherited;
  UpdateWidth := True;
end;

procedure TMStatus.SetGaugeBoxColor(Value: TColor);
begin
  if Value <> FGaugeBoxColor then
    begin
      FGaugeBoxColor := Value;
      Gauge.Color := Value;
      Refresh;
    end;
end;

procedure TMStatus.SetGaugeHint(Value: String);
begin
  if Value <> FGaugeHint then
    begin
      FGaugeHint := Value;
      Gauge.Hint := Value;
      Refresh;
    end;
end;

procedure TMStatus.SetGaugeMax(Value: LongInt);
begin
  if Value <> FGaugeMax then
    begin
      FGaugeMax := Value;
      Gauge.MaxValue := Value;
      Refresh;
    end;
end;

procedure TMStatus.SetGaugeMin(Value: LongInt);
begin
  if Value <> FGaugeMin then
    begin
      FGaugeMin := Value;
      Gauge.MinValue := Value;
      Refresh;
    end;
end;

procedure TMStatus.SetGaugeProgress(Value: LongInt);
begin
  if Value <> FGaugeProgress then
    begin
      FGaugeProgress := Value;
      Gauge.Progress := Value;
      Refresh;
    end;
end;

procedure TMStatus.MShowHint(Sender: TObject);
begin
  if application.hint=''
    then self.caption:='miks computers inc.'
    else self.Caption := Application.Hint;
end;




end.

