unit MIKS;

interface

uses
  {$IFDEF WIN32} Windows, {$ELSE} WinTypes, WinProcs, {$ENDIF} SysUtils,
  Messages, Classes, Graphics, DsgnIntf, Controls, Forms, Dialogs, StdCtrls, Menus,
  ExtCtrls, Buttons, Clipbrd, RxCombos, Spin;

(* MFlame *)

type
  dosto=0..100;    {MIKS}
  DoDvesta=0..199; {MIKS}
  
  PFlameField = ^TMFlameField;
  TMFlameField = Array[DoSto,0..159] of Word;
  PBitmapData = ^TBitmapData;
  TBitmapData = Array[DoDvesta,0..319] of Byte;

type
  TFireColor=(FireRed, FireGreen, FireBlue, FireMIKS, FireCyan, FireBrown); {MIKS Add-ON}

  TMFlame = class(TGraphicControl)
  private
    constructor Create(aowner:tcomponent); override;
    destructor Destroy; override;
    procedure Paint; override;
  protected
    Timer1:TTimer; {MIKS}
    TmpImage, FImage: TBitmap;
    FBitmap: PBitmapData;
    FColorAdd: Byte;
    FAutoFire:Boolean;
    FFadeOut:Boolean;
    FFireInterval:integer;
    FFlameField: PFlameField;
    FBottomRange: DoDvesta;
    FFireColor:TFireColor; {MIKS}

    procedure MakePalette; virtual;
    procedure KillPalette; virtual;
    function GetPalette: hPalette; override;
    {$IFNDEF _DELPHI3}
    procedure DrawTransparentBitmap(ahDC: hDC; xStart, yStart, x1,y1,x2,y2: Word);
    {$ENDIF}
  public
    FPalette: HPalette;
    Procedure FlameIt(sENDER:toBJECT); Virtual; {MIKS}
    procedure DoFlame; virtual;
    procedure MakeRandomLine(y: DoSto); virtual;
    procedure MakeDarkLine(y: DoSto); virtual;
    procedure SeTMFlamePixel(x, y: Byte); virtual;
    procedure SetImage(aImage: TBitmap); virtual;
    procedure SetBottomRange(Value: DoDvesta); virtual;
    procedure SetFireColor(Value: TFireColor); virtual; {MIKS}
    procedure SetAutoFire(Value: Boolean); virtual; {MIKS}
    procedure SetFadeOut(Value: Boolean); virtual; {MIKS}
    procedure SetFireInterval(Value: Integer); virtual; {MIKS}
  published
    Property AutoFire:Boolean read FAutoFire write SetAutoFire default true; {MIKS}
    Property FadeOut:Boolean read FFadeOut write SetFadeOut default false; {MIKS}
    Property FireInterval:Integer read FFireInterval write SetFireInterVal default 50; {MIKS}
    property Align;
    property Height default 200;
    property OnClick;
    property OnDblClick; {MIKS}
    property Width default 320;
    property Image: TBitmap read FImage write SetImage;
    property BottomRange: DoDvesta read FBottomRange write SetBottomRange;
    Property FireColor:TFireColor read FFireColor write SetFireColor default FireRed; {MIKS}
  end;
  

(* MPanel *)

const TMPanelVersion='1.01';
      TMDrawVersion='2.01';
      TMButtonVersion='4.11';

type StType=(stExplode,stReach,stRoll,stShutDown);

TMPanelEditor = class ( TComponentEditor )
   function GetVerbCount: Integer; override;
   function GetVerb(Index: Integer): string; override;
   procedure ExecuteVerb(Index: Integer); override;
end;

type
  TMPanel = class(TPanel)
  private
    RollLine:Boolean;
    LineColor:TColor;
    RollText:Boolean;
    FBFS:Boolean;
    FActive:Boolean;
    Vreme:Longint;
    Pause:integer;
    fx,fy,sx,sy:integer;
    Sc:String;
    Pan:Tpanel;
    RandomE,
    ARefresh:boolean;
    STB,STE:STType;
    Fm_step:integer;
    FWidth,Fheight:Integer;
    SWidth,Sheight:Integer;
    FImage:TImage;
    { Private declarations }
    Procedure SetBFS(Value:boolean);
    Procedure SetFWidth(Value:Integer);
    Procedure SetFHeight(Value:Integer);
    Procedure SetSWidth(Value:Integer);
    Procedure SetSHeight(Value:Integer);
    Procedure Setm_step(Value:Integer);
    Procedure Info(Value:Boolean);
    Procedure SetSTB(Value:STType);
    Procedure SetSTE(Value:STType);
    Procedure SetAR(Value:Boolean);
    Procedure SetRE(Value:Boolean);
    Procedure SetSC(Value:String);
    Procedure SetImage(Bmp:TImage);
    Function  IsMIKS:Boolean;
    Procedure Ref;
  protected
    { Protected declarations }
    procedure MPMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure MPMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    Procedure StartTime;
    Function  InterVal:Longint;
    Procedure DblClick; OverRide;
  published
    { Published declarations }
    property M_FinalWidth:Integer read FWidth Write SetFWidth;
    property M_FinalHeight:Integer read Fheight Write SetFheight;
    property M_StartWidth:Integer read SWidth Write SetSWidth;
    property M_StartHeight:Integer read Sheight Write SetSheight;
    property M_Step:Integer read Fm_step Write Setm_step;
    property M_RollOn:sttype read stb Write SetSTb default stExplode;
    property M_RollOff:sttype read ste Write SetSTe default stExplode;
    property M_Registrated:Boolean read IsMIKS write Info;
    property M_AutoRefresh:Boolean read Arefresh write SetAR default False;
    Property M_RandomEffect:Boolean read RandomE write SetRE default false;
    Property M_StartCaption:string read SC write SetSC;
    Property M_StartTop: integer read SY write SY;
    Property M_StartLeft: integer read SX write SX;
    Property M_FinalTop: integer read FY write FY;
    Property M_FinalLeft: integer read FX write FX;
    property M_Delay:integer read Pause write Pause;
    Property M_Active:Boolean read FActive write FActive default True;
    Property M_StartFromStartPos:Boolean read FBFS write SetBFS default True;
    Property M_RollText:Boolean read RollText write RollText default True;
    Property M_RollLine:Boolean read RollLine write RollLine default True;
    Property M_LineColor:TColor read LineColor write LineColor default clWhite;
    property M_Image:TImage read FImage write SetImage;
  end;

(* MButton *)

type
  TButtonLayout = (blGradientCaption,blCaptionCenter, blCaptionLeft, blCaptionRight, blCaptionTop, blCaptionBottom);
  TBorderWidth = 1..10;  
  TMargin = 3..25;
  TNumGlyphs = 1..3;
  TStyle = (stIE, stGradient, st98, stTripple);

  TMButton = class(TGraphicControl)
  private
    { Private declarations }
    Clicked:Boolean;
    fsb:boolean;
    F3d:Boolean;
    FFsc:TColor;
    FStyle:TStyle;
    FBeginClr : TColor;
    FEndClr : TColor;
    FStretch:Boolean;
    FBorderWidth: TBorderWidth;
    FButtonLayout: TButtonLayout;
    FCaption: TCaption;
    FClick,
    FEnter,
    FLeave,
    FGlyph: TBitmap;
    FMargin: TMargin;
    FNumGlyphs: TNumGlyphs;
    FTransparentColor: TColor;

    BtnRect, BtnRect1: TRect;
    HasMouse: boolean;

    procedure setfsb(c:boolean);
    procedure setfsc(c:TColor);
    procedure SetBeginClr(Value : TColor);
    procedure SetEndClr(Value : TColor);
    procedure SetStyle(c:TStyle);
    procedure setStretch(c:boolean);
    procedure setf3d(c:boolean);
    procedure SetBorderWidth(Value: TBorderWidth);
    procedure SetButtonLayOut(Value: TButtonLayout);
    procedure SetGlyph(Value: TBitmap);
    procedure SetEnter(Value: TBitmap);
    procedure SetClick(Value: TBitmap);
    procedure SetLeave(Value: TBitmap);
    procedure SetMargin(Value: TMargin);
    procedure SetNumGlyphs(Value: TNumGlyphs);
    procedure SetText(Value: TCaption);
    procedure SetTransparentColor(Value: TColor);
    procedure InitBtnRect;
    procedure DrawCaption;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    { Protected declarations }
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure FillHorizontal(FBeginClr,FEndClr:integer);
  published
    { Published declarations }
    property BorderWidth: TBorderWidth read FBorderWidth write SetBorderWidth default 1;
    property ButtonLayout: TButtonLayout read FButtonLayout write SetButtonLayout default blCaptionCenter;
    property Caption: TCaption read FCaption write SetText;
    property Glyph: TBitmap read FGlyph write SetGlyph;
    property BitMaPEnter: TBitmap read FEnter write SetEnter;
    property BitMaPLeave: TBitmap read FLeave write SetLeave;
    property BitMaPClick: TBitmap read FClick write SetClick;
    property Margin: TMargin read FMargin write SetMargin default 5;
    property NumGlyphs: TNumGlyphs read FNumGlyphs write SetNumGlyphs default 2;
    property TransparentColor: TColor read FTransparentColor write SetTransparentColor;
    property Style:TStyle read FStyle write SetStyle default st98;
    property Stretch:boolean read FStretch write SetStretch default false;
    property Font3d:boolean read F3d write SetF3D default false;
    property SideBlock:boolean read fsb write SetFsb default true;
    property Color;
    property Enabled;
    property Font;
    property Name;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property BeginColor : TColor read FBeginClr write SetBeginClr default clYellow;
    property EndColor : TColor read FEndClr write SetEndClr default clBtnFace;
    property FontShadowColor : TColor read FFSC write SetFSC default clWhite;
  end;

(* MDraw *)

type
  TDraws=(DrawText,DrawLine, DrawRectangle, DrawEllipse, DrawCircle, DrawKvadrat);

  TMDraw = class(TPanel)
  private
    { Private declarations }
    MBtnFont:TSpeedButton;
    MDraws:TDraws;
    MImgSB:TScrollBox;
    MBtnPanel:TScrollBox;
    MStatus:TPanel;
    MBtnLineCol:TColorComboBox;
    MBtnFillCol:TColorComboBox;
    MLineWidth:TSpinEdit;
    MTool:TComboBox;
    MFontColor:TColorComboBox;
    FontDlg:TFontDialog;
    FImageWidth:Integer;
    FImageheight:Integer;
    FLineColor:TColor;
    FFillColor:TColor;
    FLineWidth:Integer;
    MImage:TImage;
    MText:TEdit;

    Drawing:Boolean;

    Procedure SetLineColor(C:TColor);
    Procedure SetFillColor(C:TColor);
    Procedure SetLineWidth(C:Integer);
    Procedure SetImageWidth(C:Integer);
    Procedure SetImageHeight(C:Integer);
    procedure SetFontColor(c:TColor);
    Procedure LineColorChange(Sender:TObject);
    Procedure FillColorChange(Sender:TObject);
    Procedure LineWidthChange(Sender:TObject);
    Procedure ToolChange(Sender:TObject);
    Procedure FontChange(Sender:TObject);
    Procedure FontColorChange(Sender:TObject);
    Procedure FontClick(Sender:TObject);
    procedure StartDraw(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer);
    procedure EndDraw(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer);
    procedure DrawMe(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    Procedure DrawShape(Style:TPenMode);
  protected
    { Protected declarations }
  public
    { Public declarations }
    First,Last:TPoint;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure OnResize; dynamic;
    Procedure LoadPicture(S:String);
    Procedure SavePicture(S:String);
  published
    { Published declarations }
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property LineWidth:integer read FLineWidth write SetLineWidth default 1;
    property fillColor:TColor read FFillColor write SetFillColor default clWhite;
    property ImageWidth:integer read FImageWidth write SetImageWidth default 150;
    property ImageHeight:Integer read FImageHeight write SetImageHeight default 100;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MIKS', [TMPanel, TMButton, TMDraw, TMFlame]);
  RegisterComponentEditor(TMPanel, TMPanelEditor);
end;


Function PTNF(w:integer; b:boolean):Integer;
{Positive True Negative False}
begin
  if b then begin if w<0 then w:=-w end
       else begin if w>0 then w:=-w end;
  PTNF:=w;
end;

Function Oko(sta,cega,koliko:LongInt):boolean;
begin
  oko:=(Sta>=Cega-koliko) and (sta<=cega+koliko)
end;

Function PosReach(var Value: integer; ReachTo, Step:integer):boolean;
begin
  if Oko(value,ReachTo,Step+1) then PosReach:=True else begin
    PosReach:=false;
    Value:=Value+PTNF(Step,Value<ReachTo);
  end;  
end;

Procedure TMPanel.SetImage;
begin
  FImage.Assign(Bmp);
  Invalidate;
end;


Procedure TMPanel.DblClick;
var w,oldtop,oldleft,i:integer; s,old:string;
begin
  if FActive then begin
    if m_Delay>0 then Arefresh:=True;
    If RandomE then Case Random(4) of
      0:stb:=stShutDown;
      1:stb:=stRoll;
      2:stb:=stExplode;
      3:stb:=stReach;
    end;
    if (Top<>FY) or (Left<>FX) then begin
      Caption:='';
      OldTop:=FY;
      OldLeft:=FX;

      w:=top;   while not PosReach (w,oldtop,m_step) do top:=w;
      w:=Left;  while not PosReach (W,oldLeft,m_step) do Left:=w;

      if m_step>0 then case stb of
        stShutDown:begin

          w:=Left;
          While Left<W+fWidth div 2- sWidth div 2 do
          begin
            Left:=Left+m_step;
            ref;
          end;

          w:=Top;
          While Top<W+fHeight div 2- sheight div 2 do begin
            Top:=Top+m_step;
            ref;
          end;

          while height>BevelWidth*2+2 do begin
            height:=height-m_step;
            ref;
          end;

          height:=BevelWidth*2+2;
          while (width<fwidth) or (left>oldleft)  do begin
            if left>oldleft then
              left:=left-PTNF(m_step,Left > OldLeft );
            if width<fwidth then
              width:=width+PTNF(m_step, fWidth>Width )*2;
            ref;
          end;

          while (top>oldtop) or (height<fheight) do begin
            if top>oldtop
              then top:=top-m_step;
            if height<fheight
              then height:=height+m_step* 2;
            ref
          end;

        end;
        stexplode:begin
          w:=oldtop+fHeight div 2-sheight div 2;
          while top<w do begin
            top:=top+m_step;
            ref
          end;
          w:=oldleft+fWidth div 2-swidth div 2;
          while left<w do begin
            left:=left+m_step;
            ref;
          end;
          While(top>OldTop) or (left>oldLeft) or
               (Width<fWidth) or (height<fHeight) do begin
            if top>oldtop then top:=top-PTNF(m_step,top > oldtop );
            if left>oldleft then left:=left-PTNF(m_step,left > OldLeft );
            if width<fwidth then width:=width+PTNF(m_step,width < fWidth )*2;
            if height<fheight then height:=height+PTNF(m_step,height<fHeight )*2;
            ref;
          end;
        end;
        stRoll:begin
          while top<>OldTop do begin
            top:=top+PTNF(m_step,top<OldTop );
            ref
          end;
          while left<>OldLeft do begin
            left:=left+PTNF(m_step,Left < Oldleft );
            ref;
          end;
          while (Width<fWidth) or (Height<fheight) do begin
            if Width<fWidth then Width:=width+PTNF(m_step,fWidth > Width );
            if height<fHeight then Height:=Height+PTNF(m_step,fHeight > Height );
            ref;
          end;
        end;
        stReach:begin
          while top<>OldTop do begin
            top:=top+PTNF(m_step,top<OldTop );
            ref
          end;
          while left<>OldLeft do begin
            left:=left+PTNF(m_step,Left < Oldleft );
            ref;
          end;
         while Width<m_finalWidth do begin
           Width:=width+PTNF(m_step,fwidth > width );
           ref;
         end;
         while Height<m_finalheight do begin
           Height:=Height+PTNF(m_step,fheight > height );
           ref;
         end;
       end;
      end;
      w:=top;   while not PosReach (w,Fy,m_step) do top:=w;
      w:=Left;  while not PosReach (W,FX,m_step) do Left:=w;
      w:=Height;while not PosReach (W,Fheight,m_step) do height:=w;
      w:=Width; while not PosReach (W,FWidth,m_step) do width:=w;

      if RollLine then With Canvas do begin
        Pen.Width:=2;
        For i:=0 to FWidth do begin
           Canvas.Pen.Color:=LineColor;
           MoveTo(i,0); LineTo(0,(Fheight * i div FWidth));
           if i>0 then begin
             Canvas.Pen.Color:=Color;
             MoveTo(i-1,0); LineTo(0,(Fheight * (i-1) div FWidth));
           end;
         end;
         With Canvas do For i:=0 to FWidth do begin
           Canvas.Pen.Color:=LineColor;
           MoveTo(i,Fheight);
           LineTo(FWidth,(Fheight * i div FWidth));
           if i>0 then begin
             Canvas.Pen.Color:=Color;
             MoveTo(i-1,Fheight);
             LineTo(FWidth,(Fheight * (i-1) div FWidth));
           end;
         end;
         Pen.Mode:=pmCopy;
         Pen.Width:=1;
      end;
      
      getdir(0,old);
      if not isMIKS then
        Canvas.TextOut(1,1,'Unregistrated version');

    end else if m_step>0 then begin
      OldTop:=SY;
      OldLeft:=SX;

      case StE of
       stShutDown:begin
         w:=Top;
         While (top<W+fHeight div 2+bevelWidth) or
               (height>BevelWidth*2+2) do begin
           if top<W+fHeight div 2+bevelWidth then
             Top:=Top+m_step;
           if height>BevelWidth*2+2 then Height:=Height-m_step*2;
           Ref;
         end;
         height:=BevelWidth*2+2;
         w:=Left;
         While (width>sWidth) or
               (left>W+fWidth div 2-sheight div 2) do begin
           if width>sWidth then Width:=Width-m_step * 2;
           if left<W+ fWidth div 2-sheight div 2
             then left:=left+m_step;
           Ref;
         end;
         While (height<sHeight) do begin
           Height:=Height+m_step *2;
           Top:=Top-m_step;
           Ref;
         end;
       end;
       stExplode:While (width>swidth) or (height>sheight) do begin
            if left<>oldleft+fwidth div 2 - swidth div 2
              then left:=left+PTNF(m_step,fWidth > sWidth );
            if width>swidth then width:=width-
              PTNF(m_step,m_startWidth<Width )*2;
            if top<>oldtop+Fheight div 2 - Sheight div 2
              then top:=top+PTNF(m_step,fy > sx );
            if height>sheight then
              height:=height-PTNF(m_step,SHeight < height )*2;
            ref;
          end;
       STRoll:while (width>SWidth) or (Height>Sheight) do begin
           if width<>SWidth then Width:=width-PTNF(m_step,Width>SWidth );
           if height<>SHeight then Height:=Height-PTNF(m_step,height>SHeight );
           ref;
         end;
       stReach:begin
         while width>SWidth do begin
           Width:=width-PTNF(m_step,Width>SWidth);
           ref;
         end;
         while Height>sheight do begin
           Height:=Height-PTNF(m_step,height>SHeight );
           ref;
         end;
       end;
      end;
      w:=top;   while not PosReach (w,Sy,m_step) do top:=w;
      w:=Left;  while not PosReach (W,Sx,m_step) do Left:=w;
      w:=Height;while not PosReach (W,Sheight,m_step) do height:=w;
      w:=Width; while not PosReach (W,SWidth,m_step) do width:=w;
      Caption:=SC;
    end;
  end;
  inherited DblClick;
end;

Function TMPanel.IsMIKS;
var old:String;
begin
  getdir(0,old);
  {$i-} chdir('c:\miks'); {$I+}
  IsMIKS:=ioresult=0;
  chdir(old);
end;

Procedure TMPanel.SetFWidth;
begin  if Value>Swidth then  FWidth:=value else fWidth:=SWidth+1; end;

Procedure TMPanel.SetFheight;
begin  if Value>Sheight then  Fheight:=Value else FHeight:=SHeight+1; end;

Procedure TMPanel.SetSWidth;
begin  if value<FWidth then  SWidth:=value else SWidth:=FWidth-1; end;

Procedure TMPanel.SetSheight;
begin if Value<Fheight then  Sheight:=Value else SHeight:=FHeight-1; end;

Procedure TMPanel.Setm_step;
begin Fm_step:=Value; end;

constructor TMPanel.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   vreme:=-1;
   Caption:= '>';
   FWidth:=100;
   Fheight:=100;
   SWidth:= 25;
   SHeight:= 25;
   Width:=SWidth;
   Height:=SHeight;
   Caption:=name+'>';
   m_startCaption:='>';
   m_step:=3;
   Font.Style:=[fsBOLD];
   BevelInner:=bvLowered;
   BorderStyle:=bsSingle;
   ParentColor:=True;
   ShowHint:=True;
   Hint:='Double click to roll on/off';
   ARefresh:=False;
   RandomE:=False;
   Randomize;
   m_startLeft:=Left;
   m_startTop:=Top;
   m_finalTop:=Top+Height;
   m_finalLeft:=Left+Width;
   FActive:=True;
   rolltext:=True;
   fbfs:=true;
   RollLine:=True;
   LineColor:=ClWhite;
end;

Procedure TMPanel.Info;
begin
  if not ismiks then Application.MessageBox
    ('TMPanel Roll On/Off panel version: '+
      TMPanelversion+#13+#10+
      'MIKS compan-y by Emir Kurtovic',
     'About', MB_OK or MB_ICONINFORMATION);
end;

Procedure TMPanel.SetSTB;
begin
  STB:=value;
end;

Procedure TMPanel.SetSC;
begin
  SC:=value;
  if FBFS then Caption:=SC;
end;

Procedure TMPanel.SetSTe;
begin
  STe:=value;
end;

Procedure TMPanel.SetAR;
begin
  ARefresh:=value;
end;

Procedure TMPanel.SetRE;
begin
  RandomE:=value;
end;

Procedure TMPanel.SetBFS;
begin
  FBFS:=value;
  if FBFS then begin
    Top:=SY;
    Left:=SX;
    Width:=SWidth;
    Height:=Sheight;
    Caption:=m_StartCaption;
  end;
end;

Procedure TMPanel.Ref;
begin
  If ARefresh then Refresh;
  If m_Delay>0 then begin
    StartTime;
    Repeat
      Application.ProcessMessages;
    Until Interval>m_Delay;
  end;  
end;

Procedure TMPanel.StartTime;
Var H,M,S:Word;
begin
  DecodeTime(Time,H,H,S,M);
  Vreme:=S*1000+M;
end;

Function  TMPanel.InterVal;
Var H,m,S:Word; l:Longint;
begin
  if vreme>0 then begin
    DecodeTime(Time,H,H,s,M);
    l:=s;
    l:=l*1000+m;
    l:=l-Vreme;
    if l<0
      then Interval:=m_Delay+1
      else InterVal:=L;
  end else interVal:=M_Delay+1;
end;

function TMPanelEditor.GetVerbCount: Integer;
begin
   Result := 11;
end;

function TMPanelEditor.GetVerb(Index: Integer): String;
begin
  case Index of
  0: Result := 'set to &Start coords';
  1: Result := 'set to &Final coords';
  2: Result := '&Begin from [Start] pos';
  3: Result := '-';
  4: Result := 'Go to s&tart';
  5: Result := 'Go to f&inal';
  6: Result := '-';
  7: Result := 'S&hutDown';
  8: Result := '&Explode';
  9: Result := '&Roll';
 10: Result := 'Rea&ch';
  end;
end;

procedure TMPanelEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
  0: begin
       with TMPanel(Component) do begin
         SetSWidth(Width);
         SetSHeight(Height);
         SY:=Top;
         SX:=Left;
         Width:=SWidth;
         height:=Sheight;
         SC:=Caption;
       end;
       Designer.Modified;
     end;
  1: begin
       With TMPanel(component) do begin
         SetFWidth(Width);
         setfheight(Height);
         fY:=Top;
         fX:=Left;
         Width:=fWidth;
         Height:=FHeight;
         Caption:='';
       end;
       Designer.Modified;
     end;
   2:begin
       TMPanel(component).SetBFS(True);
       Designer.Modified;
     end;
   3:;
   4:begin
      with TMPanel(component) do begin
        Width:=SWidth;
        height:=SHeight;
        Top:=SY;
        Left:=SX;
        Caption:=SC;
      end;
      Designer.Modified;
   end;
   5:begin
      with TMPanel(component) do begin
        Width:=FWidth;
        height:=FHeight;
        Top:=FY;
        Left:=FX;
        Caption:='';
      end;
      Designer.Modified;
   end;
   6:;
   7:begin
      TMPanel(component).STB:=stShutDown;
      TMPanel(component).STE:=stShutDown;
      Designer.Modified;
     end;
  8:begin
      TMPanel(component).STB:=stExplode;
      TMPanel(component).STE:=stExplode;
      Designer.Modified;
     end;
  9: begin
      TMPanel(component).STB:=stroll;
      TMPanel(component).STE:=stroll;
      Designer.Modified;
     end;
  10: begin
      TMPanel(component).STB:=stReach;
      TMPanel(component).STE:=streach;
      Designer.Modified;
     end;
  end;
end;

procedure TMPanel.MPMouseEnter(var Message: TMessage);
var s:String; k,j,i:integer;
begin
  s:=Caption;
  if s<>'' then if (Rolltext) then for k:=1 to 2 do for i:=1 to 3 do begin
    caption:='';
    for j:=1 to i do caption:=caption+' ';
    Caption:=caption+'>';
    StartTime;
    Refresh;
    Repeat Until Interval>50;
  end;
  if Width<FWidth
    then begin
       Caption:=s
    end else begin
      caption:='';
    end;
  Invalidate;
end;

procedure TMPanel.MPMouseLeave(var Message: TMessage);
begin
  Font.Color:=clBtnText;
  if Width<FWidth
    then Caption:=SC
    else Caption:='';
  Invalidate;
end;

destructor  TMpanel.Destroy;
begin
  fimage.Free;
  inherited destroy;
end;


(* MButton *)

Procedure TMButton.InitBtnRect;
begin
  with self do begin
    BtnRect := rect(0,0,width,height);
    BtnRect1 := rect(1,1,width-1,height-1);
  end;
end;

procedure TMButton.DrawCaption;
var
  TopLeft: TPoint;
  fc:TColor;

begin

  with Canvas do
  begin
    Font.Color := Self.Font.Color;
    Font.Name := Self.Font.Name;
    Font.Size := Self.Font.Size;
    if not hasmouse
      then Font.Style := Self.Font.Style
      else font.style:=[fsBold];
    Brush.Style := bsClear;
  end;

  case ButtonLayout of
    blCaptionCenter: begin
                       TopLeft.X := (Width - Canvas.TextWidth(Caption)) div 2;
                       TopLeft.Y := (Height - Canvas.TextHeight(Caption)) div 2;
                     end;
    blCaptionTop:    begin
                       TopLeft.X := (Width - Canvas.TextWidth(Caption)) div 2;
                       TopLeft.Y := FMargin;
                     end;
    blCaptionBottom: begin
                       TopLeft.X := (Width - Canvas.TextWidth(Caption)) div 2;
                       TopLeft.Y := (Height - Canvas.TextHeight(Caption)) - FMargin;
                     end;
    blCaptionLeft:   begin
                       TopLeft.X := FMargin;
                       TopLeft.Y := (Height - Canvas.TextHeight(Caption)) div 2;
                     end;
    blGradientCaption:begin
                       TopLeft.X := FMargin+15;
                       TopLeft.Y := (Height - Canvas.TextHeight(Caption)) div 2;
                     end;
    blCaptionRight:  begin
                       TopLeft.X := (Width - Canvas.TextWidth(Caption)) - FMargin;
                       TopLeft.Y := (Height - Canvas.TextHeight(Caption)) div 2;
                     end;

  end;

  if Caption <> '' then
  with Canvas do
  begin
     if Enabled then begin
        fc:=Font.Color;
        if Font3d then begin
          Font.Color:=ffsc;
          TextOut(TopLeft.X+1, TopLeft.Y+1, Caption);
        end;
        Font.Color:=fc;
        TextOut(TopLeft.X, TopLeft.Y, Caption);
     end
     else
     begin
       Font.Color := clWhite;
       TextOut(TopLeft.X + 1, TopLeft.Y + 1, Caption);
       Font.Color := clGrayText;
       TextOut(TopLeft.X, TopLeft.Y, Caption);
     end;

  end;
end;

procedure TMButton.SetBorderWidth(Value: TBorderWidth);
begin
  if (Value <> FBorderWidth) and (Value >= 1) and (Value < 10) then
  begin
    FBorderWidth := Value;
    SetMargin(Value + 2);
    invalidate;
  end;
end;

procedure TMButton.SetButtonLayout(Value: TButtonLayout);
begin
  if Value <> FButtonLayout then
  begin
     FButtonLayout := Value;
     invalidate;
  end;
end;

procedure TMButton.SetGlyph(Value: TBitmap);
begin
  FGlyph.Assign(Value);
end;
procedure TMButton.SetEnter(Value: TBitmap);
begin
  FEnter.Assign(Value);
end;

procedure TMButton.SetBeginClr(Value : TColor);
begin
  if FBeginClr <> Value then begin
    FBeginClr := Value;
    Invalidate;
  end;
end;

procedure TMButton.SetEndClr(Value : TColor);
begin
  if FEndClr <> Value then begin
    FEndClr := Value;
    Invalidate;
  end;
end;

procedure TMButton.SetClick(Value: TBitmap);
begin
  FClick.Assign(Value);
end;

procedure TMButton.SetLeave(Value: TBitmap);
begin
  FLeave.Assign(Value);
end;


procedure TMButton.SetMargin(Value: TMargin);
begin
  if (Value <> FMargin) and (Value > FBorderWidth + 1) then
  begin
    FMargin := Value;
    invalidate
  end;
end;

procedure TMButton.SetNumGlyphs(Value: TNumGlyphs);
begin
  if (Value <> FNumGlyphs) and (Value <= 3) and (Value > 0) then
  begin
    FNumGlyphs := Value;
    invalidate;
  end;
end;

procedure TMButton.SetText(Value: TCaption);
begin
  if Value <> FCaption then FCaption := Value;
  invalidate;
end;

procedure TMButton.SetTransparentColor(Value: TColor);
begin
  if Value <> FTransparentColor then
  begin
    FTransparentColor := Value;
    invalidate;
  end;
end;

constructor TMButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fsb:=true;
  F3d:=false;
  FBeginClr:=ClYellow;
  FEndClr:=ClBtnFace;
  FFsc:=ClWhite;
  clicked:=False;
  style:=st98;
  BorderWidth := 1;
  ButtonLayout := blCaptionCenter;
  Canvas.Brush.Color := Color;
  Canvas.Brush.Style := bsSolid;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Color := clBtnFace;
  canvas.font.name:='Arial';
  FGlyph := TBitmap.Create;
  FEnter := TBitmap.create;
  FLeave := TBitMap.Create;
  FClick := TbitMap.Create;
  Font := Canvas.Font;
  HasMouse := false;
  Height := 25;
  Margin := 5;
  FNumGlyphs := 2;
  Width := 25;
end;

destructor TMButton.Destroy;
begin
  FGlyph.Free;
  FEnter.Free;
  FLeave.Free;
  FClick.Free;
  inherited Destroy;
end;

procedure TMButton.CMMouseEnter(var Message: TMessage);
begin
  HasMouse := true;
  if Enabled then
  begin
    InitBtnRect;
    invalidate;
    Frame3D(Canvas, BtnRect, clBtnHighLight, clBtnShadow, FBorderWidth);
  end;
end;

procedure TMButton.CMMouseLeave(var Message: TMessage);
begin
  HasMouse := false;
  if Enabled then
  begin
    InitBtnRect;
    invalidate;
    Frame3D(Canvas, BtnRect1, color,color,FBorderWidth);
  end;
end;

procedure TMButton.Paint;
var
  R,GlyphRect, BitmapRect: TRect;
  TopLeft: TPoint;
  PartGlyphWidth: integer;
begin
  InitBtnRect;

  with Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := Color;
    Pen.Color := clBtnFace;
  end;

  {
  Canvas.Rectangle(0, 0, Width, Height);
  }

  if (csDesigning in ComponentState) then
  begin
    InitBtnRect;
    Frame3D(Canvas, BtnRect, clBtnHighLight, clBtnShadow, FBorderWidth);
  end;

    case ButtonLayout of
      blCaptionCenter: begin
                         TopLeft.X := (Self.Width - (FGlyph.Width div NumGlyphs)) div 2;
                         TopLeft.Y := (Self.Height - FGlyph.Height) div 2;
                       end;
      blCaptionTop:    begin
                         TopLeft.X := (Self.Width - (FGlyph.Width div NumGlyphs)) div 2;
                         TopLeft.Y := (Self.Height - FGlyph.Height) - Margin;
                       end;
      blCaptionBottom: begin
                         TopLeft.X := (Self.Width - (FGlyph.Width div NumGlyphs)) div 2;
                         TopLeft.Y := Margin;
                       end;
      blCaptionLeft:   begin
                         TopLeft.X := (Self.Width - (FGlyph.Width div NumGlyphs)) - Margin;
                         TopLeft.Y := (Self.Height - FGlyph.Height) div 2;
                       end;
      blCaptionRight:  begin
                         TopLeft.X := Margin;
                         TopLeft.Y := (Self.Height - FGlyph.Height) div 2;
                       end;
    end;

  GlyphRect := Rect(TopLeft.X, TopLeft.Y, TopLeft.X + (FGlyph.Width div NumGlyphs), TopLeft.Y + FGlyph.Height);

  PartGlyphWidth := FGlyph.Width div NumGlyphs;

  if Enabled and HasMouse then
  case style of
    stgradient:begin
      FillHorizontal(FBeginClr,FEndClr);
      with canvas do if sideblock then begin
        pen.width:=0;
        brush.Style:=bsSolid;
        pen.mode:=pmCopy;
        pen.color:=FFSC;
        brush.color:=FFsc;
        rectangle(0,0,10,height);
        MoveTo(0,height);
        LineTo(width,height);
      end;
    end;
    sttripple:begin
      if Clicked then
      begin
        if Stretch then begin
          R:=Rect(0,0,Width,Height);
          Canvas.Stretchdraw(R,FClick);
        end else Canvas.draw(0,0,FClick);
      end else if Stretch then
      begin
        R:=Rect(0,0,Width,Height);
        Canvas.Stretchdraw(R,FEnter);
      end else Canvas.draw(0,0,FEnter);
    end;
    st98:begin
       BitmapRect := Rect(0, 0, PartGlyphWidth, FGlyph.Height);
       Frame3D(Canvas, BtnRect, clWhite, clBlack, FBorderWidth);
       Frame3D(Canvas, BtnRect1, clWhite, clBlack, FBorderWidth);
    end;
    stIE:begin
       BitmapRect := Rect(0, 0, PartGlyphWidth, FGlyph.Height);
       Frame3D(Canvas, BtnRect, clwhite, clGray, FBorderWidth);
    end;
  end;

  if Enabled and not HasMouse then
  case style of
    stgradient:with canvas do if sideblock then begin
      Brush.color:=FBeginClr;
      pen.color:=FbeginClr;
      pen.width:=2;
      rectangle(0,0,10,Height);
      MoveTo(0,height);
      lineto(width,height);
    end;
    sttripple:begin
      if stretch then begin
        R:=Rect(0,0,Width,Height);
        Canvas.Stretchdraw(R,FLeave);
      end else Canvas.draw(0,0,FLeave);
    end;
    st98:begin
      BitmapRect := Rect(FGlyph.Width - PartGlyphWidth, 0, PartGlyphWidth * NumGlyphs, FGlyph.Height);
      Frame3D(Canvas, BtnRect1, Color, Color, FBorderWidth);
      Frame3D(Canvas, BtnRect, clWhite, clBlack, FBorderWidth);
    end;
    stIE:begin
      BitmapRect := Rect(FGlyph.Width - PartGlyphWidth, 0, PartGlyphWidth * NumGlyphs, FGlyph.Height);
      Frame3D(Canvas, BtnRect, Color, Color, FBorderWidth);
    end;
  end;

  if not Enabled and (FNumGlyphs > 1) then
     BitmapRect := Rect(PartGlyphWidth, 0, PartGlyphWidth * 2, FGlyph.Height);
  if not Enabled and (FNumGlyphs = 1) then
     BitmapRect := Rect(0, 0, PartGlyphWidth, FGlyph.Height);

  Canvas.BrushCopy(GlyphRect, FGlyph, BitmapRect, TransparentColor);

  DrawCaption;
end;

procedure TMButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Enabled then begin
    InitBtnRect;
    case style of
      st98:begin
        Frame3D(Canvas, BtnRect1, clBlack, clWhite, FBorderWidth);
        Frame3D(Canvas, BtnRect, clGray, clBlack, FBorderWidth);
      end;
      stIE:begin
        Frame3D(Canvas, BtnRect, clBlack, clWhite, FBorderWidth);
        Frame3D(Canvas, BtnRect1, clGray, clBlack, FBorderWidth);
      end;
      stTripple:begin
        Clicked:=True;
        invalidate;
      end;
      stgradient:begin
        FillHorizontal(FEndClr,FBeginClr);
        DrawCaption;
      end;
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TMButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Enabled then
  begin
    InitBtnRect;
    if HasMouse then
    case style of
      stGradient:begin
       invalidate;
      end;
      stTripple:begin
         Clicked:=False;
         invalidate;
      end;
      st98:begin
         Frame3D(Canvas, BtnRect, clwhite, clGray, FBorderWidth);
         Frame3D(Canvas, BtnRect1, clWhite, clBlack, FBorderWidth);
      end;
      stIE:begin
        Frame3D(Canvas, BtnRect1, Color, Color, FBorderWidth);
        Frame3D(Canvas, BtnRect, clwhite, clGray, FBorderWidth);
      end;
    end else case style of
      stTripple:;
      else Frame3D(Canvas, BtnRect, Color, Color, FBorderWidth);
    end;
  end;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure tmbutton.setStretch(c:boolean);
begin
  fStretch:=c;
  invalidate;
end;

procedure tmbutton.setstyle(c:tstyle);
begin
  fstyle:=c;
  case c of
    stGradient:ButtonLayOut:=blGradientCaption;
  end;
  invalidate;
end;

procedure tmbutton.setfsc(c:TColor);
begin
  ffsc:=c;
  invalidate;
end;

procedure tmbutton.setf3d(c:boolean);
begin
  f3d:=c;
  invalidate
end;

procedure tmbutton.setfsb(c:boolean);
begin
  fsb:=c;
  invalidate
end;


procedure TMButton.FillHorizontal(FBeginClr,FEndClr:integer);
var
  fr,fg,fb,dr,dg,db:integer;
  ColorRect: TRect;
  I: Integer;
  d, R, G, B : Byte;
begin
  FR := FBeginClr and $000000ff;
  FG := (FBeginClr shr 8) and $000000ff;
  FB := (FBeginClr shr 16) and $000000ff;

  DR := (FEndClr and $000000ff) - FR;
  DG := ((FEndClr shr 8) and $000000ff) - FG;
  DB := ((FEndClr shr 16) and $000000ff) - FB;

  ColorRect.Top:= 0;
  ColorRect.Bottom := self.Height;
  if SideBlock then d:=15 else d:=0;
  for I := 0 to 255 do begin
    ColorRect.Left:= MulDiv (I, width, 256);
    ColorRect.Right:= MulDiv (I + 1, width, 256);
    R := fr + MulDiv(I, dr, 255);
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    with Canvas do begin
      Brush.Color := RGB(R, G, B);
      if colorrect.left>d then Canvas.FillRect(ColorRect);
    end;
  end;
end;

(* MDraw *)


constructor TMDraw.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent := TWinControl(AOwner);
  BorderStyle:=bsSingle;
  Ctl3d:=False;
  BevelInner:=bvLowered;
  BorderWidth:=2;
  MDraws:=DrawLine;
  Drawing:=False;
  First:=Point(0,0);
  Last:=Point(0,0);
  ShowHint:=True;
  FImageWidth:=150;
  FImageHeight:=150;

  FontDlg:=TFontDialog.CreaTE(sELF);

  MBtnPanel:=TScrollBox.Create(Self);
  With MBtnPanel do begin
    Parent:=Self;
    bevelInner:=bvLowered;
    Align:=AlTop;
    Height:=25;
    Hint:='Opcije';
  end;

  MImgSB:=TScrollBox.create(Self);
  with MImgSB do begin
    Parent:=Self;
    Align:=AlClient;
    BorderWidth:=2;
    bevelOuter:=bvNone;
    BorderStyle:=bssingle;
  end;

  MStatus:=TPanel.Create(Self);
  With MStatus do begin
    Parent:=Self;
    bevelOuter:=bvLowered;
    Alignment:=taLeftJustify;
    Align:=AlBottom;
    Height:=20;
    Hint:='Status';
  end;

  MImage:=TImage.Create(self);
  with MImage do begin
    Parent:=MImgSB;
    Align:=AlNone;
    OnMouseDown:=StartDraw;
    OnMouseUp:=EndDraw;
    OnMouseMove:=DrawMe;
    Stretch:=False;
    Picture:=TPicture.Create;
    Width:=200;
    Height:=200;
  end;


  FLineColor:=ClBlack;
  MBtnLineCol:=TColorComboBox.Create(Self);
  With MBtnLineCol do begin
    DisplayNames:=False;
    Color:=ClWindow;
    Parent:=MBtnPanel;
    Align:=AlLeft;
    Width:=50;
    ColorValue:=FLineColor;
    Hint:='Boja linije';
    OnChange:=LineColorChange;
  end;

  FFillColor:=ClWhite;
  MBtnFillCol:=TColorComboBox.Create(Self);
  With MBtnFillCol do begin
    Parent:=MBtnPanel;
    DisplayNames:=False;
    Color:=ClWindow;
    Align:=AlLeft;
    Width:=50;
    ColorValue:=FFillColor;
    hint:='Boja izpunjavanja';
    OnChange:=FillColorChange;
  end;

  MFontColor:=TColorComboBox.Create(Self);
  With MFontColor do begin
    Parent:=MBtnPanel;
    DisplayNames:=False;
    Colorvalue:=clBlack;
    Align:=AlLeft;
    Width:=50;
    hint:='Boja teksta';
    OnChange:=FontColorChange;
  end;

  MLineWidth:=TSpinEdit.Create(self);
  With MLineWidth do begin
    parent:=MBtnPanel;
    Hint:='Debljina linije';
    Value:=1;
    Align:=AlLeft;
    Width:=40;
    OnChange:=LineWidthChange;
  end;

  MTool:=TComboBox.Create(Self);
  With MTool do begin
    Parent:=MBtnPanel;
    Width:=130;
    Align:=AlLeft;
    Sorted:=True;
    Clear;
    Items.Add('Linija');
    Items.Add('Tekst');
    Items.Add('Pravougaonik');
    Items.Add('Kvadrat');
    Items.Add('Elipsa');
    Items.Add('Krug');
    OnChange:=ToolChange;
  end;

  mbTNfONT:=TSpeedButton.Create(Self);
  with mbTNfONT do begin
    OnClick:=FontClick;
    parent:=MBtnPanel;
    Align:=AlLeft;
    Caption:='Fnt';
    Hint:='Font';
  end;

  MText:=TEdit.Create(Self);
  With MText do begin
    parent:=MBtnPanel;
    Align:=AlClient;
    Text:='';
    Hint:='Tekst';
  end;
end;

destructor TMDraw.Destroy;
begin
  inherited Destroy;
end;

Procedure TMDraw.FontClick;
begin
  With FontDlg do if execute then MImage.Canvas.Font:=Font;
end;

procedure TMDraw.StartDraw(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer);
begin
  Drawing:=True;
  First:=Point(x,y);
  Last:=First;
  MImage.Canvas.MoveTo(x,y);
  MStatus.Caption:=Format('Pozicija (%d,%d)',[x,y]);
end;

procedure TMDraw.EndDraw(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer);
begin
  if drawing then begin
    Last:=Point(x,y);
    DrawShape(pmCopy);
    Drawing:=False;
  end;
  MStatus.Caption:=Format('Pozicija (%d,%d)',[x,y]);
end;

procedure TMDraw.DrawMe(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Drawing then
  begin
    DrawShape(pmNotXor);
    Last := Point(X, Y);
    DrawShape(pmNotXor);
  end;
  MStatus.Caption:=Format('Pozicija (%d,%d)',[x,y]);
end;

Procedure TMDraw.DrawShape(Style:TPenMode);
var o1,o2,o3:TPoint;
begin
  o1:=First;
  o2:=Last;
  if (First.x>last.x) or (First.y>last.y) then begin
    o3:=last;
    last:=First;
    First:=o3;
  end;
  if drawing then with MImage.Canvas do begin
    Pen.Mode:=Style;
    MoveTo(First.X,First.Y);
    case MDraws of
      DrawLine:LineTo(Last.X,Last.Y);
      DrawRectangle:Rectangle(First.X,First.Y,Last.X,Last.Y);
      DrawKvadrat:Rectangle(First.X,First.Y,Last.x,Last.x);
      DrawCircle:Ellipse(First.X,First.Y,Last.X,Last.X);
      DrawEllipse:Ellipse(First.X,First.Y,Last.X,Last.Y);
      DrawText:TextOut(First.X,First.Y,MText.Text);
    end;
  end;
  First:=o1;
  Last:=o2;
end;

Procedure TMDraw.LineColorChange(Sender:TObject);
begin
  SetLineColor(MBtnLineCol.ColorValue);
end;

Procedure TMDraw.FillColorChange(Sender:TObject);
begin
  SetFillColor(MBtnFillCol.ColorValue);
end;

Procedure TMDraw.LineWidthChange(Sender:TObject);
begin
  SetLineWidth(MLineWidth.Value);
end;

Procedure TMDraw.SetLineColor;
begin
  FLineColor:=C;
  MImage.Canvas.Pen.Color:=FLineColor;
end;

Procedure TMDraw.SetFillColor;
begin
  FFillColor:=C;
  MImage.Canvas.Brush.Color:=FFillColor;
end;

Procedure TMDraw.SetLineWidth;
begin
  FLineWidth:=C;
  MImage.Canvas.Pen.Width:=c;
end;

Procedure TMDraw.SetImageWidth(C:Integer);
begin
  FImageWidth:=C;
  MImage.Width:=C;
end;

Procedure TMDraw.SetFontColor(C:TColor);
begin
  MFontColor.ColorValue:=c;
  FontDlg.Font.Color:=C;
  MImage.Canvas.Font.Color:=c;
end;


Procedure TMDraw.SetImageHeight(C:Integer);
begin
  MImage.Height:=C;
  FImageHeight:=C;
end;

Procedure TMDraw.OnResize;
begin
  With MImage do begin
    Width:=FImageWidth;
    Height:=FImageHeight;
  end;
  invalidate;
end;

Procedure TMDraw.ToolChange;
begin
  if UpperCase(MTool.Text)='ELIPSA' then MDraws:=DrawEllipse;
  if UpperCase(MTool.Text)='PRAVOUGAONIK' then MDraws:=DrawRectangle;
  if UpperCase(MTool.Text)='KVADRAT' then MDraws:=DrawKvadrat;
  if UpperCase(MTool.Text)='LINIJA' then MDraws:=DrawLine;
  if UpperCase(MTool.Text)='KRUG' then MDraws:=DrawCircle;
  if UpperCase(MTool.Text)='TEKST' then MDraws:=DrawText;
end;

Procedure TMDraw.LoadPicture(S:String);
begin
  if FileSearch(s,'.')<>'' then begin
    With MImage do begin
      Picture.LoadFromFile(S);
      Width:=Picture.Width;
      Height:=Picture.Height;
    end;
  end;
end;

Procedure TMDraw.SavePicture(S:String);
begin
  MImage.Picture.SaveToFile(S);
end;

Procedure TMDraw.FontChange(Sender:TObject);
begin
  MImage.Canvas.Font:=FontDlg.Font;
  MFontColor.ColorValue:=FontDlg.Font.Color;
end;

Procedure TMDraw.FontColorChange(Sender:TObject);
begin
  MImage.Canvas.Font.Color:=MFontColor.ColorValue;
  FontDlg.Font.Color:=MFontColor.ColorValue;
end;

constructor TMFlame.Create;
begin
  inherited Create(aOwner);
  Timer1:=TTimer.Create(self);
  Timer1.Interval:=50;
  FireInterval:=50;
  Timer1.Enabled:=True;
  Timer1.OnTimer:=FlameIt;
  FFadeOut:=False;
  FAutoFire:=True;
  FFireColor:=FireRed;
  MakePalette;
  FColorAdd := 0;
  Height := 200;
  Width := 320;
  New(FBitmap);
  New(FFlameField);
  FillChar(FBitmap^, 64000, 0);
  FillChar(FFlameField^, 32000, 0);
  FImage := TBitmap.Create;
  TmpImage := TBitmap.Create;
end;

destructor TMFlame.Destroy;
begin
  TmpImage.Free;
  FImage.Free;
  Dispose(FFlameField);
  Dispose(FBitmap);
  KillPalette;  
  inherited Destroy;
end;

procedure TMFlame.Paint;
var
  DC, mDC: hDC;
  BitsInfo: pBitmapInfo;
  i: Integer;
  OldPal: hPalette;
  MemB, MemOld:hBitmap;
begin
  DC := Canvas.Handle;
  GetMem(bitsinfo, SizeOf(TBitmapInfoHeader) + 256 * 2);
  with BitsInfo^ do
   begin
    with bmIHeader do
     begin
      biSize := 40;
      biWidth := 320;
      biHeight := 200;
      biPlanes := 1;
      biBitCount := 8;
      biCompression := 0;
      biSizeImage := 64000;
      biXPelsPerMeter := 0;
      biYPelsPerMeter := 0;
      biClrUsed := 256;
      biClrImportant := 256;
    end;
    for i := 0 to 127 do
     begin
      bmIColors[i].RGBBlue := 2 * i + FColorAdd;
      bmIColors[i].RGBGreen := 0;
      bmIColors[i].RGBRed := 2 * i + 1 + FColorAdd;
      bmIColors[i].RGBReserved := 0;
    end;
  end;
  mDC := TmpImage.Canvas.Handle;
  MemB := CreateCompatibleBitmap (DC, 320, 200);
  MemOld := SelectObject(mDC, MemB);
  OldPal := SelectPalette(mDC, FPalette, False);

  SetDIBitsToDevice(mDC, 0, 0, Width, Height, 0, 0, 0, 200, FBitmap, BitsInfo^, DIB_Pal_Colors);
  {$IFDEF _Delphi3}
  Image.Transparent := True;
  Image.TransparentColor := 0;
  TmpImage.Canvas.Draw(Width div 2 - Image.Width div 2, Height div 2 - Image.Height div 2,Image);
  {$ELSE}
  DrawTransparentBitmap(mDC, Width div 2 - Image.Width div 2, Height div 2 - Image.Height div 2,
                          0,0, Image.Width,Image.Height);
  {$ENDIF}
  BitBlt(DC, 0, 0, Width, Height - FBottomRange, mDC, 0, 0, SrcCopy);

  DeleteObject(SelectObject(mDC, MemOld));

  FreeMem(BitsInfo, SizeOf(TBitmapInfoHeader) + 256 * 2);
  SelectPalette(DC, OldPal, False);
end;

procedure TMFlame.MakePalette;
var
  Pal: PLogPalette;
  i: Integer;

  procedure SetPalettereg(c,r,g,b: Byte);
  begin
    case FFireColor of
      FireRed:Begin
        Pal^.PalPalEntry[c].PeRed:=r shl 2;
        Pal^.PalPalEntry[c].PeGreen:=g shl 2;
        Pal^.PalPalEntry[c].PeBlue:=b shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
      FireGreen:Begin
        Pal^.PalPalEntry[c].PeRed:=g shl 2;
        Pal^.PalPalEntry[c].PeGreen:=r shl 2;
        Pal^.PalPalEntry[c].PeBlue:=b shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
      FireBlue:Begin
        Pal^.PalPalEntry[c].PeRed:=b shl 2;
        Pal^.PalPalEntry[c].PeGreen:=g shl 2;
        Pal^.PalPalEntry[c].PeBlue:=r shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
      FireMIKS:Begin
        Pal^.PalPalEntry[c].PeRed:=r shl 2;
        Pal^.PalPalEntry[c].PeGreen:=g shl 2;
        Pal^.PalPalEntry[c].PeBlue:=r shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
      FireCyan:Begin
        Pal^.PalPalEntry[c].PeRed:=b shl 2;
        Pal^.PalPalEntry[c].PeGreen:=r shl 2;
        Pal^.PalPalEntry[c].PeBlue:=r shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
      FireBrown:Begin
        Pal^.PalPalEntry[c].PeRed:=r shl 2;
        Pal^.PalPalEntry[c].PeGreen:=r shl 2;
        Pal^.PalPalEntry[c].PeBlue:=b shl 2;
        Pal^.PalPalEntry[c].PeFlags:=0;
      end;
    end;
  end;
               
begin
  GetMem(Pal, 4 + 256 * 4);
  FillChar(Pal^, 4 + 256 * 4, 0);
  Pal^.PalVersion := $300;
  Pal^.PalNumEntries := 256;
  for i:=0 to 63 do SetPaletteReg(i, i, 0, 0);
  for i:=0 to 63 do SetPaletteReg(64 + i, 63, i, 0);
  for i:=0 to 63 do SetPaletteReg(128 + i, 63, 63, i);
  for i:=0 to 63 do SetPaletteReg(192 + i, 63, 63, 63);
  FPalette:=CreatePalette(Pal^);
  FreeMem(Pal, 4 + 256 * 4);
end;

procedure TMFlame.KillPalette;
begin
  DeleteObject(FPalette);
end;

function TMFlame.GetPalette;
begin
  GetPalette:=FPalette;
end;

procedure TMFlame.DoFlame;
type
  Giant = array[0..$FFFE] of byte;
var
  FieldPtr, BitmapPtr: Pointer;
  y, x, w, ax, fpt, bpt: Word;
  bt: Array[1..2] of Byte;
begin
  FieldPtr := FFlameField;
  BitmapPtr := FBitmap;
  for y := 0 to 97 do
{$IFDEF WIN32}
   begin
    bpt := 640 * (99 - y);
    fpt := 320 * y;
    for x := 1 to 160 do
     begin
      move(Giant(FieldPtr^)[fpt + 159 * 2], w, 2);
      ax := w;
      move(Giant(FieldPtr^)[fpt + 160 * 2], w, 2);
      ax := w + ax;
      move(Giant(FieldPtr^)[fpt + 161 * 2], w, 2);
      ax := w + ax;
      move(Giant(FieldPtr^)[fpt + 320 * 2], w, 2);
      ax := w + ax;
      ax := ax shr 2;
      if ax <> 0 then dec(ax);
      move(ax, Giant(FieldPtr^)[fpt], 2);
      inc(fpt, 2);
      bt[1] := Lo(ax);
      bt[2] := bt[1];
      Move(bt, ax, 2);
      move(ax, Giant(BitmapPtr^)[bpt - 1], 2);
      move(ax, Giant(BitmapPtr^)[bpt - 321], 2);
      dec(bpt, 2);
     end;
{$ELSE}
     asm
      push ds
      les di, BitmapPtr
      mov ax,640
      mov bx,99
      sub bx,y
      mul bx
      add di,ax

      lds si, FieldPtr
      mov ax,320
      mul y
      add si,ax

      mov cx,160
    @schleifex:

      mov ax,[si+159*2]
      add ax,[si+160*2]
      add ax,[si+161*2]
      add ax,[si+320*2]
      shr ax,2
      cmp ax,0
      je @keindec
      dec ax
    @keindec:
      mov [si],ax
      add si,2
      mov ah,al
      mov es:[di-1],ax
      mov es:[di-321],ax
      sub di,2

      loop @schleifex
      pop ds
{$ENDIF}
   end;
  Paint;
end;                      

procedure TMFlame.MakeRandomLine;
var
  x: Word;
begin
  for x := 10 to 149 do
   FFlameField^[y, x]:=Random(2)*256;
end;

const B:integer=255;

procedure TMFlame.MakeDarkLine;
var
  x: Word;
begin
  for x := 10 to 149 do
   FFlameField^[y, x]:=Random(2)+Random(b);
  if b>0 then b:=b-1 else begin
    SetAutoFire(False);
    SetFadeOut(False);
    b:=255;
    if csDesigning in ComponentState then invalidate;
  end;
end;


procedure TMFlame.SeTMFlamePixel;
begin
  if (x < 0) or (x > 159) or (y < 0) or (y > 199) then Exit;
  FFlameField^[y, x] := 256;
end;

procedure TMFlame.SetImage;
begin
  FImage.Assign(aImage);
  Invalidate;
end;

procedure TMFlame.SetBottomRange;
begin
  FBottomRange := Value;
  Invalidate;
end;

procedure TMFlame.SetFireColor(Value: TFireColor); {MIKS}
begin
  FFireColor:=Value;
  MakePalette;
  Invalidate;
end;

procedure TMFlame.SetAutoFire(Value: Boolean); 
begin
  FAutoFire:=Value;
  Timer1.Enabled:=FAutoFire;
  Invalidate;
end;

procedure TMFlame.SetFadeOut(Value: Boolean); 
begin
  FFadeOut:=Value;
  Invalidate;
end;

Procedure TMFlame.FlameIt;
begin
  if not ffadeout
    then makeRandomLine(98+Random(2))
    else MakeDarkLine(98+Random(2));
  DoFlame;
end;

Procedure TMFlame.SetFireInterval;
begin
  FFireInterval:=Value;
  Timer1.Interval:=Value;
end;


{$IFNDEF _Delphi3}
procedure TMFlame.DrawTransparentBitmap(ahdc: HDC;
                                 xStart, yStart, x1,y1,x2,y2: Word);
var
  TransparentColor: TColor;
  cColor          : TColorRef;
  bmAndBack,
  bmAndObject,
  bmAndMem,
  bmSave,
  bmBackOld,
  bmObjectOld,
  bmMemOld,
  bmSaveOld       : HBitmap;
  hdcMem,
  hdcBack,
  hdcObject,
  hdcTemp,
  hdcSave         : HDC;
  ptSize          : TPoint;
begin
  { set the transparent to black }
  TransparentColor := 0;
  TransparentColor := TransparentColor or $02000000;

  hdcTemp := CreateCompatibleDC (ahdc);
  SelectObject (hdcTemp, FImage.Handle); { select the bitmap }

  { convert bitmap dimensions from device to logical points }
  ptSize.x := x2-x1;
  ptSize.y := y2-y1;
  DPToLP (hdcTemp, ptSize, 1);  { convert from device logical points }

  { create some DCs to hold temporary data }
  hdcBack   := CreateCompatibleDC(ahdc);
  hdcObject := CreateCompatibleDC(ahdc);
  hdcMem    := CreateCompatibleDC(ahdc);
  hdcSave   := CreateCompatibleDC(ahdc);

  { create a bitmap for each DC }

  { monochrome DC }
  bmAndBack   := CreateBitmap (ptSize.x, ptSize.y, 1, 1, nil);
  bmAndObject := CreateBitmap (ptSize.x, ptSize.y, 1, 1, nil);

  bmAndMem    := CreateCompatibleBitmap (ahdc, ptSize.x, ptSize.y);
  bmSave      := CreateCompatibleBitmap (ahdc, ptSize.x, ptSize.y);

  { each DC must select a bitmap object to store pixel data }
  bmBackOld   := SelectObject (hdcBack, bmAndBack);
  bmObjectOld := SelectObject (hdcObject, bmAndObject);
  bmMemOld    := SelectObject (hdcMem, bmAndMem);
  bmSaveOld   := SelectObject (hdcSave, bmSave);

  { set proper mapping mode }
  SetMapMode (hdcTemp, GetMapMode (ahdc));

  { save the bitmap sent here, because it will be overwritten }
  BitBlt (hdcSave, 0, 0, ptSize.x, ptSize.y, hdcTemp, x1, y1, SRCCOPY);

  { set the background color of the source DC to the color.
    contained in the parts of the bitmap that should be transparent }
  cColor := SetBkColor (hdcTemp, TransparentColor);

  { create the object mask for the bitmap by performing a BitBlt()
    from the source bitmap to a monochrome bitmap }
  BitBlt (hdcObject, 0, 0, ptSize.x, ptSize.y, hdcTemp, x1, y1, SRCCOPY);

  { set the background color of the source DC back to the original color }
  SetBkColor (hdcTemp, cColor);

  { create the inverse of the object mask }
  BitBlt (hdcBack, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, NOTSRCCOPY);

  { copy the background of the main DC to the destination }
  BitBlt (hdcMem, 0, 0, ptSize.x, ptSize.y, ahdc, xStart, yStart, SRCCOPY);

  { mask out the places where the bitmap will be placed }
  BitBlt (hdcMem, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, SRCAND);

  { mask out the transparent colored pixels on the bitmap }
  BitBlt (hdcTemp, x1, y1, ptSize.x, ptSize.y, hdcBack, 0, 0, SRCAND);

  { XOR the bitmap with the background on the destination DC }
  BitBlt (hdcMem, 0, 0, ptSize.x, ptSize.y, hdcTemp, x1, y1, SRCPAINT);

  { copy the destination to the screen }
  BitBlt (ahdc, xStart, yStart, ptSize.x, ptSize.y, hdcMem, 0, 0, SRCCOPY);

  { place the original bitmap back into the bitmap sent here }
  BitBlt (hdcTemp, x1, y1, ptSize.x, ptSize.y, hdcSave, 0, 0, SRCCOPY);

  { delete the memory bitmaps }
  DeleteObject (SelectObject (hdcBack, bmBackOld));
  DeleteObject (SelectObject (hdcObject, bmObjectOld));
  DeleteObject (SelectObject (hdcMem, bmMemOld));
  DeleteObject (SelectObject (hdcSave, bmSaveOld));

  { delete the memory DCs }
  DeleteDC (hdcMem);
  DeleteDC (hdcBack);
  DeleteDC (hdcObject);
  DeleteDC (hdcSave);
  DeleteDC (hdcTemp);
end;
{$ENDIF}


end.

